//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 文字列テストヘッダ
 * @author Junpee
 */

#ifndef STRING_TEST_H_
#define STRING_TEST_H_

#include <LampUnit/TestCase.h>

//------------------------------------------------------------------------------
/**
 * 文字列テスト
 */
class StringTest : public TestCase{
public:
	/**
	 * コンストラクタ
	 * @param name テストの名前
	 */
	explicit StringTest(String name);

	/**
	 * テストを実行する
	 */
	virtual void runTest(){}

	/**
	 * テストスィートの取得
	 * @return テストスィート
	 */
	static Test* suite();

	// コンストラクタテスト
	virtual void testConstructor();

	// パーステスト
	virtual void testParse();

	// 追加テスト
	virtual void testAppend();

	// フォーマットテスト
	virtual void testFormat();

	// 部分文字列テスト
	virtual void testSubstring();

	// 大文字小文字テスト
	virtual void testUpperLower();

	// 比較テスト
	virtual void testCompare();

	// 大文字小文字を無視する比較テスト
	virtual void testCompareIgnoreCase();

	// 開始一致、終了一致テスト
	virtual void testStartsWithEndsWith();

	// インデックステスト
	virtual void testIndex();

private:
	// NULL文字列
	String null_;
	// あいう文字列
	String aiu_;

};

//------------------------------------------------------------------------------
#endif // End of STRING_TEST_H_
//------------------------------------------------------------------------------
